Package weka.gui.scripting

# Class ScriptingPanel

java.lang.Object
java.awt.Component
java.awt.Container
javax.swing.JComponent
javax.swing.JPanel
weka.gui.scripting.ScriptingPanel

All Implemented Interfaces:
  `ImageObserver`, `MenuContainer`, `Serializable`, `Accessible`, `TitleUpdatedListener`

Direct Known Subclasses:
  `FileScriptingPanel`, `SimpleCLIPanel`

public abstract class ScriptingPanel extends JPanel implements TitleUpdatedListener
Abstract ancestor for scripting panels.

Version:
  $Revision: 15291 $
Author:
  fracpete (fracpete at waikato dot ac dot nz)
See Also:
  - Serialized Form

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class javax.swing.JComponent

  `JComponent.AccessibleJComponent`

  ## Nested classes/interfaces inherited from class java.awt.Component

  `Component.BaselineResizeBehavior`

- ## Field Summary

  ### Fields inherited from class javax.swing.JComponent

  `TOOL_TIP_TEXT_KEY, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

  ### Fields inherited from class java.awt.Component

  `BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

  ### Fields inherited from interface java.awt.image.ImageObserver

  `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ScriptingPanel()`
  Default constructor.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addTitleUpdatedListener(TitleUpdatedListener l)`
  Adds the listener to the internal list.
  `boolean`
  `getDebug()`
  Returns whether debugging mode is on.
  `abstract ImageIcon`
  `getIcon()`
  Returns an icon to be used in a frame.
  `abstract JMenuBar`
  `getMenuBar()`
  Returns the menu bar to to be displayed in the frame.
  `abstract JTextPane`
  `getOutput()`
  Returns the text area that is used for displaying output on stdout and stderr.
  `abstract String`
  `getTitle()`
  Returns the current title for the frame/dialog.
  `void`
  `removeTitleUpdatedListener(TitleUpdatedListener l)`
  Removes the listener from the internal list.
  `void`
  `setDebug(boolean value)`
  Turns on/off debugging mode.
  `static void`
  `showPanel(ScriptingPanel panel, String[] args)`
  Displays the panel in a frame.
  `static void`
  `showPanel(ScriptingPanel panel, String[] args, int width, int height)`
  Displays the panel in a frame.
  `void`
  `terminate()`
  Terminates this panel, i.e., terminates the output threads it started.
  `void`
  `titleUpdated(TitleUpdatedEvent event)`
  Gets called when the title of the frame/dialog needs updating.

  ### Methods inherited from class javax.swing.JPanel

  `getAccessibleContext, getUI, getUIClassID, setUI, updateUI`

  ### Methods inherited from class javax.swing.JComponent

  `addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintImmediately, paintImmediately, print, printAll, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

  ### Methods inherited from class java.awt.Container

  `add, add, add, add, add, addContainerListener, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate`

  ### Methods inherited from class java.awt.Component

  `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, contains, createImage, createImage, createVolatileImage, createVolatileImage, dispatchEvent, enable, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocusInWindow, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setMixingCutoutShape, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

  ### Methods inherited from class java.lang.Object

  `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### ScriptingPanel

    public ScriptingPanel()
    Default constructor.

- ## Method Details

  - ### terminate

    public void terminate()
    Terminates this panel, i.e., terminates the output threads it started. Removes the output and error streams from the corresponding tees as well so that garbage collection succeeds.

  - ### getIcon

    public abstract ImageIcon getIcon()
    Returns an icon to be used in a frame.
    Returns:
      the icon

  - ### getTitle

    public abstract String getTitle()
    Returns the current title for the frame/dialog.
    Returns:
      the title

  - ### getOutput

    public abstract JTextPane getOutput()
    Returns the text area that is used for displaying output on stdout and stderr.
    Returns:
      the JTextArea

  - ### getMenuBar

    public abstract JMenuBar getMenuBar()
    Returns the menu bar to to be displayed in the frame.
    Returns:
      the menu bar, null if not applicable

  - ### setDebug

    public void setDebug(boolean value)
    Turns on/off debugging mode.
    Parameters:
      `value` - if true, debug mode is turned on

  - ### getDebug

    public boolean getDebug()
    Returns whether debugging mode is on.
    Returns:
      true if debug mode is turned on

  - ### addTitleUpdatedListener

    public void addTitleUpdatedListener(TitleUpdatedListener l)
    Adds the listener to the internal list.
    Parameters:
      `l` - the listener to add

  - ### removeTitleUpdatedListener

    public void removeTitleUpdatedListener(TitleUpdatedListener l)
    Removes the listener from the internal list.
    Parameters:
      `l` - the listener to remove

  - ### titleUpdated

    public void titleUpdated(TitleUpdatedEvent event)
    Gets called when the title of the frame/dialog needs updating.
    Specified by:
      `titleUpdated` in interface `TitleUpdatedListener`
    Parameters:
      `event` - the event that got sent

  - ### showPanel

    public static void showPanel(ScriptingPanel panel, String[] args)
    Displays the panel in a frame.
    Parameters:
      `panel` - the panel to display
      `args` - currently ignored commandline parameters

  - ### showPanel

    public static void showPanel(ScriptingPanel panel, String[] args, int width, int height)
    Displays the panel in a frame.
    Parameters:
      `panel` - the panel to display
      `args` - currently ignored commandline parameters
      `width` - the width of the frame
      `height` - the height of the frame